#include "fudgeish.hpp"

#ifndef CERR
#define CERR std::cerr << __FILE__ << ":" << std::dec << __LINE__ << " : "
#endif

#ifndef COUT
#define COUT std::cout << __FILE__ << ":" << std::dec << __LINE__ << " : "
#endif

#ifdef DO_S11N
#  include "fudgeish_s11n_1_2.hpp"
#  include <s11n.net/s11n/s11nlite.hpp>
#endif // DO_S11N

#ifdef DO_S11N
// install a proxy for DiceBag::list_type()
#  include <s11n.net/s11n/proxy/std/list.hpp>
#endif

void do_dice()
{
	int dcount = 4;
	int result = 0;
	fudge::DiceBag bag( dcount );
	for( int i = 0; i < 10; i++ )
	{
		result = bag.roll();
		COUT << "Rolling dice bag ("<<dcount<<" dice): " << result << "\n";
#ifdef DO_S11N
		s11nlite::save( bag, std::cout );
		s11nlite::save( bag.dice(), std::cout );
#endif // DO_S11N
	}
}


void do_wounds()
{
	fudge::WoundChart wch;
	for( int i = fudge::WoundChart::NoEffect; i < fudge::WoundChart::NearDeath; i++ )
	{
		wch.wound( i );
		COUT << "Added wound to chart: " << wch.woundName( i ) << "\n";
#ifdef DO_S11N
 		s11nlite::save( wch, std::cout );
#endif // DO_S11N
	}
}


int main( int argc, char ** argv )
{
#ifdef DO_S11N
	s11nlite::serializer_class( "parens" );
#endif
	do_dice();
	do_wounds();
	return 0;
}
